(*
 * Copyright 2005 Toshiyuki Maeda
 *
 * This file is part of TALK.
 *
 * TALK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * TALK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *)

(* Disassemble Opcode Tables *)

type my_bool = Y | N
(* Opcode Table Template
[|
     (* 0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F *)
(* 0 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 1 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 2 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 3 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 4 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 5 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 6 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 7 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 8 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 9 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* A *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* B *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* C *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* D *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* E *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* F *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
|]
*)

let is_prefix_array =
[|
     (* 0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F *)
(* 0 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 1 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 2 *) N; N; N; N; N; N; Y; N; N; N; N; N; N; N; Y; N;
(* 3 *) N; N; N; N; N; N; Y; N; N; N; N; N; N; N; Y; N;
(* 4 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 5 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 6 *) N; N; N; N; N; N; Y; Y; N; N; N; N; N; N; N; N;
(* 7 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 8 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 9 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* A *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* B *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* C *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* D *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* E *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* F *) Y; N; Y; Y; N; N; N; N; N; N; N; N; N; N; N; N;
|]
let is_prefix b = is_prefix_array.(b) = Y

let is_2byte_op_escape_array =
[|
     (* 0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F *)
(* 0 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; Y;
(* 1 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 2 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 3 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 4 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 5 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 6 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 7 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 8 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 9 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* A *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* B *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* C *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* D *) N; N; N; N; N; N; N; N; Y; Y; Y; Y; Y; Y; Y; Y;
(* E *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* F *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
|]
let is_2byte_op_escape b = is_2byte_op_escape_array.(b) = Y

let is_1byte_modrm_op_array =
[|
     (* 0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F *)
(* 0 *) Y; Y; Y; Y; N; N; N; N; Y; Y; Y; Y; N; N; N; N;
(* 1 *) Y; Y; Y; Y; N; N; N; N; Y; Y; Y; Y; N; N; N; N;
(* 2 *) Y; Y; Y; Y; N; N; N; N; Y; Y; Y; Y; N; N; N; N;
(* 3 *) Y; Y; Y; Y; N; N; N; N; Y; Y; Y; Y; N; N; N; N;
(* 4 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 5 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 6 *) N; N; Y; Y; Y; Y; Y; Y; N; Y; N; Y; N; N; N; N;
(* 7 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 8 *) Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y;
(* 9 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* A *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* B *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* C *) Y; Y; N; N; Y; Y; Y; Y; N; N; N; N; N; N; N; N;
(* D *) Y; Y; Y; Y; N; N; N; N; N; N; N; N; N; N; N; N;
(* E *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* F *) N; N; N; N; N; N; Y; Y; N; N; N; N; N; N; Y; Y;
|]
let is_1byte_modrm_op b = is_1byte_modrm_op_array.(b) = Y

let is_2byte_modrm_op_0F_array =
[|
     (* 0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F *)
(* 0 *) Y; Y; Y; Y; N; N; N; N; N; N; N; N; N; N; N; N;
(* 1 *) Y; Y; Y; Y; Y; Y; Y; Y; Y; N; N; N; N; N; N; N;
(* 2 *) Y; Y; Y; Y; Y; N; Y; N; Y; Y; Y; Y; Y; Y; Y; Y;
(* 3 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 4 *) Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y;
(* 5 *) Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y;
(* 6 *) Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y;
(* 7 *) Y; Y; Y; Y; Y; Y; Y; N; N; N; N; N; Y; Y; Y; Y;
(* 8 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 9 *) Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y;
(* A *) N; N; N; Y; Y; Y; N; N; N; N; N; Y; Y; Y; Y; Y;
(* B *) Y; Y; Y; Y; Y; Y; Y; Y; N; Y; Y; Y; Y; Y; Y; Y;
(* C *) Y; Y; Y; Y; Y; Y; Y; Y; N; N; N; N; N; N; N; N;
(* D *) Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y;
(* E *) Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y;
(* F *) Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; Y; N;
|]
let is_2byte_modrm_op_0F b = is_2byte_modrm_op_0F_array.(b) = Y

let is_1byte_group_op_array =
[|
     (* 0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F *)
(* 0 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 1 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 2 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 3 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 4 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 5 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 6 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 7 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 8 *) Y; Y; Y; Y; N; N; N; N; N; N; N; N; N; N; N; N;
(* 9 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* A *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* B *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* C *) Y; Y; N; N; N; N; Y; Y; N; N; N; N; N; N; N; N;
(* D *) Y; Y; Y; Y; N; N; N; N; N; N; N; N; N; N; N; N;
(* E *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* F *) N; N; N; N; N; N; Y; Y; N; N; N; N; N; N; Y; Y;
|]
let is_1byte_group_op b = is_1byte_group_op_array.(b) = Y

let is_2byte_group_op_0F_array =
[|
     (* 0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F *)
(* 0 *) Y; Y; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 1 *) N; N; N; N; N; N; N; N; Y; N; N; N; N; N; N; N;
(* 2 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 3 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 4 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 5 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 6 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 7 *) N; Y; Y; Y; N; N; N; N; N; N; N; N; N; N; N; N;
(* 8 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* 9 *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* A *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; Y; N;
(* B *) N; N; N; N; N; N; N; N; N; Y; Y; N; N; N; N; N;
(* C *) N; N; N; N; N; N; N; Y; N; N; N; N; N; N; N; N;
(* D *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* E *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
(* F *) N; N; N; N; N; N; N; N; N; N; N; N; N; N; N; N;
|]
let is_2byte_group_op_0F b = is_2byte_group_op_0F_array.(b) = Y
