(*
 * Copyright 2005 Toshiyuki Maeda
 *
 * This file is part of TALK.
 *
 * TALK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * TALK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *)

open Types


let ie_inte inte = IEInte inte
let ie_int i = ie_inte (IConst (Big_int.big_int_of_int i))

(*
let ie_add ie1 ie2 = IEArith (A_ADD, ie1, ie2)
let ie_mul ie1 ie2 = IEArith (A_MUL, ie1, ie2)
*)

let (+..) ie1 ie2 = IEArith (A_ADD, ie1, ie2)
let ( *..) ie1 ie2 = IEArith (A_MUL, ie1, ie2)

(*
let ic_equal ie1 ie2 = ICCmp ((C_EQ, true), ie1, ie2)
let ic_ge ie1 ie2 = ICCmp ((C_GE, true), ie1, ie2)
*)

let (=..) ie1 ie2 = ICCmp ((C_EQ, true), ie1, ie2)
let (<>..) ie1 ie2 = ICCmp ((C_NEQ, true), ie1, ie2)
let (<=..) ie1 ie2 = ICCmp ((C_LE, true), ie1, ie2)
let (<..) ie1 ie2 = ICCmp ((C_LT, true), ie1, ie2)
let (>=..) ie1 ie2 = ICCmp ((C_GE, true), ie1, ie2)
let (>..) ie1 ie2 = ICCmp ((C_GT, true), ie1, ie2)

let negate_cop_r = function
	| C_EQ -> C_NEQ
	| C_NEQ -> C_EQ
	| C_LT -> C_GE
	| C_GT -> C_LE
	| C_LE -> C_GT
	| C_GE -> C_LT

let negate = function
	| ICCmp ((cop_r, signed), ie1, ie2) ->
		let cop_r = negate_cop_r cop_r in
		ICCmp ((cop_r, signed), ie1, ie2)
