(*
 * Copyright 2005 Toshiyuki Maeda
 *
 * This file is part of TALK.
 *
 * TALK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * TALK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *)

open Types

open Util

open Format

(************************************
	Routine for Printing Types
 ************************************)

let output_any converter outputter ppf (ctx, a) =
	let state = Types_op.context_to_state ctx in
	let (state, a) = converter state a in
	fprintf ppf "@[%a@]" outputter a

let output_context ppf ctx =
	let state = Types_op.context_to_state ctx in
	let (state, _) = Convert_to_readable.convert_state state in
	fprintf ppf "@[%a@]" Output_readable_types.output_state state

let output_tv = output_any
	Convert_to_readable.convert_tv
	Output_readable_types.output_tv

let output_cs = output_any
	Convert_to_readable.convert_cs
	Output_readable_types.output_cs

let output_inte = output_any
	Convert_to_readable.convert_integer
	Output_readable_types.output_inte

let output_inte_expr = output_any
	Convert_to_readable.convert_integer_expr
	Output_readable_types.output_inte_expr

let output_inte_cstrt = output_any
	Convert_to_readable.convert_integer_cstrt
	Output_readable_types.output_inte_cstrt

let output_inte_cstrts = output_any
	Convert_to_readable.convert_integer_cstrts
	Output_readable_types.output_inte_cstrts

let output_store = output_any
	Convert_to_readable.convert_store
	Output_readable_types.output_store

let output_code_store = output_any
	Convert_to_readable.convert_code_store
	Output_readable_types.output_code_store

let output_regs_type = output_any
	Convert_to_readable.convert_registers_type
	Output_readable_types.output_regs_type

let output_ct = output_any
	Convert_to_readable.convert_concrete_type
	Output_readable_types.output_ct

let output_nt = output_any
	Convert_to_readable.convert_named_type
	Output_readable_types.output_nt

let output_pt = output_any
	Convert_to_readable.convert_pack_type
	Output_readable_types.output_pt

let output_type = output_any
	Convert_to_readable.convert_type
	Output_readable_types.output_type

let output_at = output_any
	Convert_to_readable.convert_array_type
	Output_readable_types.output_at

let output_code = output_any
	Convert_to_readable.convert_code_type
	Output_readable_types.output_code
